package cn.citycraft.ResExtras;

import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;

import com.bekvon.bukkit.residence.protection.FlagPermissions;

import cn.citycraft.PluginHelper.config.FileConfig;
import cn.citycraft.PluginHelper.utils.VersionChecker;
import cn.citycraft.ResExtras.flags.animalkilling;
import cn.citycraft.ResExtras.flags.bat;
import cn.citycraft.ResExtras.flags.blaze;
import cn.citycraft.ResExtras.flags.blockdamage;
import cn.citycraft.ResExtras.flags.cavespider;
import cn.citycraft.ResExtras.flags.chicken;
import cn.citycraft.ResExtras.flags.commands;
import cn.citycraft.ResExtras.flags.cow;
import cn.citycraft.ResExtras.flags.creeperspawn;
import cn.citycraft.ResExtras.flags.drops;
import cn.citycraft.ResExtras.flags.eggs;
import cn.citycraft.ResExtras.flags.enderman;
import cn.citycraft.ResExtras.flags.enderpearl;
import cn.citycraft.ResExtras.flags.falldamage;
import cn.citycraft.ResExtras.flags.fishing;
import cn.citycraft.ResExtras.flags.form;
import cn.citycraft.ResExtras.flags.ghast;
import cn.citycraft.ResExtras.flags.god;
import cn.citycraft.ResExtras.flags.grow;
import cn.citycraft.ResExtras.flags.hunger;
import cn.citycraft.ResExtras.flags.irongolem;
import cn.citycraft.ResExtras.flags.lightning;
import cn.citycraft.ResExtras.flags.magmacube;
import cn.citycraft.ResExtras.flags.melt;
import cn.citycraft.ResExtras.flags.mobkilling;
import cn.citycraft.ResExtras.flags.mooshroom;
import cn.citycraft.ResExtras.flags.ocelot;
import cn.citycraft.ResExtras.flags.pickup;
import cn.citycraft.ResExtras.flags.pig;
import cn.citycraft.ResExtras.flags.pigsaddle;
import cn.citycraft.ResExtras.flags.pigzap;
import cn.citycraft.ResExtras.flags.portal;
import cn.citycraft.ResExtras.flags.shear;
import cn.citycraft.ResExtras.flags.sheep;
import cn.citycraft.ResExtras.flags.silverfish;
import cn.citycraft.ResExtras.flags.skeleton;
import cn.citycraft.ResExtras.flags.slime;
import cn.citycraft.ResExtras.flags.slimesplit;
import cn.citycraft.ResExtras.flags.sneak;
import cn.citycraft.ResExtras.flags.snowgolem;
import cn.citycraft.ResExtras.flags.spider;
import cn.citycraft.ResExtras.flags.sprint;
import cn.citycraft.ResExtras.flags.squid;
import cn.citycraft.ResExtras.flags.time;
import cn.citycraft.ResExtras.flags.trade;
import cn.citycraft.ResExtras.flags.vehicleprotect;
import cn.citycraft.ResExtras.flags.villager;
import cn.citycraft.ResExtras.flags.villagerkilling;
import cn.citycraft.ResExtras.flags.weather;
import cn.citycraft.ResExtras.flags.witch;
import cn.citycraft.ResExtras.flags.witherspawn;
import cn.citycraft.ResExtras.flags.wolf;
import cn.citycraft.ResExtras.flags.zombie;
import cn.citycraft.ResExtras.flags.zombiepigmen;

public class ResExtras extends JavaPlugin implements CommandExecutor {
	public FileConfig config;

	@Override
	public boolean onCommand(final CommandSender sender, final Command cmd, final String label, final String[] args) {
		if (sender instanceof Player) {
			if (args.length == 0) {
				sendHelp(sender);
			}
			if (args.length == 1) {
				switch (args[0].toLowerCase()) {
				case "version":
					if (sender.hasPermission("ResExtras.version")) {
						sender.sendMessage("§6[§bResExtras§6] §av2.0.5 §6重制 §dBy §a喵♂呜");
					}
					return true;
				case "list":
					if (sender.hasPermission("ResExtras.list")) {
						sender.sendMessage("§6[§bResExtras§6] §a 扩展Flags");
						sender.sendMessage("Zombie, Skeleton, Spider, Creeperspawn, Blaze, Cavespider, Ghast, Slime, Magmacube, Silverfish, Snowgolem, Irongolem, Enderman, Zombiepigmen, "
								+ "Chicken, Cow, Mooshroom, Ocelot, Pig, Sheep, Squid, Villager, Wolf, Bat, Witherspawn, Witch, Form, Melt, Commands, FallDamage, Portal, Enderperal, "
								+ "Mobkilling, AnimalKilling, VillagerKilling, Drops, Pickup, VehicleProtect, Lightning, Grow, Hunger, Sprint, Fishing, Eggs, Sneak, PigZap, SlimeSplit, "
								+ "Shear, PigSaddle, Trade, God, Weather, Time, BlockDamage ");
					}
					return true;
				case "help":
					sendHelp(sender);
					return true;
				}
			}
		}
		return true;
	}

	@Override
	public void onEnable() {
		final PluginManager pm = getServer().getPluginManager();
		final Plugin p = pm.getPlugin("Residence");
		if (p != null) {
			if (p.isEnabled()) {
				pm.enablePlugin(p);
				FlagPermissions.addResidenceOnlyFlag("zombie");
				FlagPermissions.addResidenceOnlyFlag("skeleton");
				FlagPermissions.addResidenceOnlyFlag("creeperspawn");
				FlagPermissions.addResidenceOnlyFlag("spider");
				FlagPermissions.addResidenceOnlyFlag("cavespider");
				FlagPermissions.addResidenceOnlyFlag("slime");
				FlagPermissions.addResidenceOnlyFlag("ghast");
				FlagPermissions.addResidenceOnlyFlag("blaze");
				FlagPermissions.addResidenceOnlyFlag("magmacube");
				FlagPermissions.addResidenceOnlyFlag("silverfish");
				FlagPermissions.addResidenceOnlyFlag("snowgolem");
				FlagPermissions.addResidenceOnlyFlag("irongolem");
				FlagPermissions.addResidenceOnlyFlag("enderman");
				FlagPermissions.addResidenceOnlyFlag("wolf");
				FlagPermissions.addResidenceOnlyFlag("zombiepigmen");
				FlagPermissions.addResidenceOnlyFlag("chicken");
				FlagPermissions.addResidenceOnlyFlag("cow");
				FlagPermissions.addResidenceOnlyFlag("mooshroom");
				FlagPermissions.addResidenceOnlyFlag("ocelot");
				FlagPermissions.addResidenceOnlyFlag("pig");
				FlagPermissions.addResidenceOnlyFlag("sheep");
				FlagPermissions.addResidenceOnlyFlag("squid");
				FlagPermissions.addResidenceOnlyFlag("villager");
				FlagPermissions.addResidenceOnlyFlag("bat");
				FlagPermissions.addResidenceOnlyFlag("witch");
				FlagPermissions.addResidenceOnlyFlag("witherspawn");
				FlagPermissions.addResidenceOnlyFlag("melt");
				FlagPermissions.addResidenceOnlyFlag("form");
				FlagPermissions.addFlag("drops");
				FlagPermissions.addFlag("pickup");
				FlagPermissions.addFlag("animalkilling");
				FlagPermissions.addFlag("villagerkilling");
				FlagPermissions.addFlag("mobkilling");
				FlagPermissions.addFlag("falldamage");
				FlagPermissions.addFlag("enderpearl");
				FlagPermissions.addFlag("commands");
				FlagPermissions.addFlag("portal");
				FlagPermissions.addFlag("vehicleprotect");
				FlagPermissions.addResidenceOnlyFlag("lightning");
				FlagPermissions.addResidenceOnlyFlag("grow");
				FlagPermissions.addFlag("hunger");
				FlagPermissions.addFlag("sprint");
				FlagPermissions.addFlag("fishing");
				FlagPermissions.addFlag("eggs");
				FlagPermissions.addFlag("sneak");
				FlagPermissions.addResidenceOnlyFlag("pigzap");
				FlagPermissions.addFlag("slimesplit");
				FlagPermissions.addFlag("shear");
				FlagPermissions.addFlag("pigsaddle");
				FlagPermissions.addFlag("trade");
				FlagPermissions.addFlag("god");
				FlagPermissions.addResidenceOnlyFlag("weather");
				FlagPermissions.addResidenceOnlyFlag("day");
				FlagPermissions.addResidenceOnlyFlag("night");
				FlagPermissions.addResidenceOnlyFlag("blockdamage");
				if (getConfig().getBoolean("Zombie", true)) {
					pm.registerEvents(new zombie(), this);
				}
				if (getConfig().getBoolean("Skeleton", true)) {
					pm.registerEvents(new skeleton(), this);
				}
				if (getConfig().getBoolean("Creeperspawn", true)) {
					pm.registerEvents(new creeperspawn(), this);
				}
				if (getConfig().getBoolean("Spider", true)) {
					pm.registerEvents(new spider(), this);
				}
				if (getConfig().getBoolean("Cavespider", true)) {
					pm.registerEvents(new cavespider(), this);
				}
				if (getConfig().getBoolean("Slime", true)) {
					pm.registerEvents(new slime(), this);
				}
				if (getConfig().getBoolean("Ghast", true)) {
					pm.registerEvents(new ghast(), this);
				}
				if (getConfig().getBoolean("Blaze", true)) {
					pm.registerEvents(new blaze(), this);
				}
				if (getConfig().getBoolean("Magmacube", true)) {
					pm.registerEvents(new magmacube(), this);
				}
				if (getConfig().getBoolean("Silverfish", true)) {
					pm.registerEvents(new silverfish(), this);
				}
				if (getConfig().getBoolean("Snowgolem", true)) {
					pm.registerEvents(new snowgolem(), this);
				}
				if (getConfig().getBoolean("Irongolem", true)) {
					pm.registerEvents(new irongolem(), this);
				}
				if (getConfig().getBoolean("Enderman", true)) {
					pm.registerEvents(new enderman(), this);
				}
				if (getConfig().getBoolean("Chicken", true)) {
					pm.registerEvents(new chicken(), this);
				}
				if (getConfig().getBoolean("Cow", true)) {
					pm.registerEvents(new cow(), this);
				}
				if (getConfig().getBoolean("Wolf", true)) {
					pm.registerEvents(new wolf(), this);
				}
				if (getConfig().getBoolean("Mooshroom", true)) {
					pm.registerEvents(new mooshroom(), this);
				}
				if (getConfig().getBoolean("Ocelot", true)) {
					pm.registerEvents(new ocelot(), this);
				}
				if (getConfig().getBoolean("Zombiepigmen", true)) {
					pm.registerEvents(new zombiepigmen(), this);
				}
				if (getConfig().getBoolean("Pig", true)) {
					pm.registerEvents(new pig(), this);
				}
				if (getConfig().getBoolean("Sheep", true)) {
					pm.registerEvents(new sheep(), this);
				}
				if (getConfig().getBoolean("Squid", true)) {
					pm.registerEvents(new squid(), this);
				}
				if (getConfig().getBoolean("Villager", true)) {
					pm.registerEvents(new villager(), this);
				}
				if (getConfig().getBoolean("Bat", true)) {
					pm.registerEvents(new bat(), this);
				}
				if (getConfig().getBoolean("Witch", true)) {
					pm.registerEvents(new witch(), this);
				}
				if (getConfig().getBoolean("Witherspawn", true)) {
					pm.registerEvents(new witherspawn(), this);
				}
				if (getConfig().getBoolean("Melt", true)) {
					pm.registerEvents(new melt(), this);
				}
				if (getConfig().getBoolean("Form", true)) {
					pm.registerEvents(new form(), this);
				}
				if (getConfig().getBoolean("Animalkilling", true)) {
					pm.registerEvents(new animalkilling(), this);
				}
				if (getConfig().getBoolean("Mobkilling", true)) {
					pm.registerEvents(new mobkilling(), this);
				}
				if (getConfig().getBoolean("Drops", true)) {
					pm.registerEvents(new drops(), this);
				}
				if (getConfig().getBoolean("Pickup", true)) {
					pm.registerEvents(new pickup(), this);
				}
				if (getConfig().getBoolean("Commands", true)) {
					pm.registerEvents(new commands(), this);
				}
				if (getConfig().getBoolean("Enderpearl", true)) {
					pm.registerEvents(new enderpearl(), this);
				}
				if (getConfig().getBoolean("Falldamage", true)) {
					pm.registerEvents(new falldamage(), this);
				}
				if (getConfig().getBoolean("Portal", true)) {
					pm.registerEvents(new portal(), this);
				}
				if (getConfig().getBoolean("Villagerkilling", true)) {
					pm.registerEvents(new villagerkilling(), this);
				}
				if (getConfig().getBoolean("Vehicleprotect", true)) {
					pm.registerEvents(new vehicleprotect(), this);
				}
				if (getConfig().getBoolean("Lightning", true)) {
					pm.registerEvents(new lightning(), this);
				}
				if (getConfig().getBoolean("Grow", true)) {
					pm.registerEvents(new grow(), this);
				}
				if (getConfig().getBoolean("Hunger", true)) {
					pm.registerEvents(new hunger(), this);
				}
				if (getConfig().getBoolean("Sprint", true)) {
					pm.registerEvents(new sprint(), this);
				}
				if (getConfig().getBoolean("Fishing", true)) {
					pm.registerEvents(new fishing(), this);
				}
				if (getConfig().getBoolean("Eggs", true)) {
					pm.registerEvents(new eggs(), this);
				}
				if (getConfig().getBoolean("Sneak", true)) {
					pm.registerEvents(new sneak(), this);
				}
				if (getConfig().getBoolean("Pigzap", true)) {
					pm.registerEvents(new pigzap(), this);
				}
				if (getConfig().getBoolean("Slimesplit", true)) {
					pm.registerEvents(new slimesplit(), this);
				}
				if (getConfig().getBoolean("Shear", true)) {
					pm.registerEvents(new shear(), this);
				}
				if (getConfig().getBoolean("Pigsaddle", true)) {
					pm.registerEvents(new pigsaddle(), this);
				}
				if (getConfig().getBoolean("Trade", true)) {
					pm.registerEvents(new trade(), this);
				}
				if (getConfig().getBoolean("God", true)) {
					pm.registerEvents(new god(), this);
				}
				if (getConfig().getBoolean("Weather", true)) {
					pm.registerEvents(new weather(), this);
				}
				if (getConfig().getBoolean("Time", true)) {
					pm.registerEvents(new time(), this);
				}
				if (getConfig().getBoolean("BlockDamage", true)) {
					pm.registerEvents(new blockdamage(), this);
				}
				this.getLogger().info("领地扩展 版本 " + this.getDescription().getVersion() + " 已正确载入 重置 By 喵♂呜");
				new VersionChecker(this);
			}
		} else {
			this.getLogger().warning("未找到 Residence 插件!");
			this.setEnabled(false);
		}
	}

	@Override
	public void onLoad() {
		config = new FileConfig(this);
	}

	public void sendHelp(final CommandSender sender) {
		sender.sendMessage("§6========= §6[§b领地扩展§6] §6插件帮助列表=========");
		sender.sendMessage("§6/ResExtras help §6- §a显示帮助页面");
		sender.sendMessage("§6/ResExtras version §6- §a显示插件版本");
		sender.sendMessage("§6/ResExtras list §6- §a显示Flags列表");
	}
}
